/*
*
* CwBdAccountingExample.java
* Copyright(C) 2017-2020 DHCC
* @date 2019-06-13
*/
package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdAccountingExample {
    /**
     * cw_bd_accounting
     */
    protected String orderByClause;

    /**
     * cw_bd_accounting
     */
    protected boolean distinct;

    /**
     * cw_bd_accounting
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public CwBdAccountingExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-06-13
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * cw_bd_accounting 2019-06-13
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkAccountingIsNull() {
            addCriterion("PK_ACCOUNTING is null");
            return (Criteria) this;
        }

        public Criteria andPkAccountingIsNotNull() {
            addCriterion("PK_ACCOUNTING is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccountingEqualTo(String value) {
            addCriterion("PK_ACCOUNTING =", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingNotEqualTo(String value) {
            addCriterion("PK_ACCOUNTING <>", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingGreaterThan(String value) {
            addCriterion("PK_ACCOUNTING >", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCOUNTING >=", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingLessThan(String value) {
            addCriterion("PK_ACCOUNTING <", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCOUNTING <=", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingLike(String value) {
            addCriterion("PK_ACCOUNTING like", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingNotLike(String value) {
            addCriterion("PK_ACCOUNTING not like", value, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingIn(List<String> values) {
            addCriterion("PK_ACCOUNTING in", values, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingNotIn(List<String> values) {
            addCriterion("PK_ACCOUNTING not in", values, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingBetween(String value1, String value2) {
            addCriterion("PK_ACCOUNTING between", value1, value2, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkAccountingNotBetween(String value1, String value2) {
            addCriterion("PK_ACCOUNTING not between", value1, value2, "pkAccounting");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNull() {
            addCriterion("PK_PREPARED is null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNotNull() {
            addCriterion("PK_PREPARED is not null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedEqualTo(String value) {
            addCriterion("PK_PREPARED =", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotEqualTo(String value) {
            addCriterion("PK_PREPARED <>", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThan(String value) {
            addCriterion("PK_PREPARED >", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED >=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThan(String value) {
            addCriterion("PK_PREPARED <", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED <=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLike(String value) {
            addCriterion("PK_PREPARED like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotLike(String value) {
            addCriterion("PK_PREPARED not like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIn(List<String> values) {
            addCriterion("PK_PREPARED in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotIn(List<String> values) {
            addCriterion("PK_PREPARED not in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedBetween(String value1, String value2) {
            addCriterion("PK_PREPARED between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotBetween(String value1, String value2) {
            addCriterion("PK_PREPARED not between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkAuditIsNull() {
            addCriterion("PK_AUDIT is null");
            return (Criteria) this;
        }

        public Criteria andPkAuditIsNotNull() {
            addCriterion("PK_AUDIT is not null");
            return (Criteria) this;
        }

        public Criteria andPkAuditEqualTo(String value) {
            addCriterion("PK_AUDIT =", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotEqualTo(String value) {
            addCriterion("PK_AUDIT <>", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditGreaterThan(String value) {
            addCriterion("PK_AUDIT >", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditGreaterThanOrEqualTo(String value) {
            addCriterion("PK_AUDIT >=", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLessThan(String value) {
            addCriterion("PK_AUDIT <", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLessThanOrEqualTo(String value) {
            addCriterion("PK_AUDIT <=", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLike(String value) {
            addCriterion("PK_AUDIT like", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotLike(String value) {
            addCriterion("PK_AUDIT not like", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditIn(List<String> values) {
            addCriterion("PK_AUDIT in", values, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotIn(List<String> values) {
            addCriterion("PK_AUDIT not in", values, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditBetween(String value1, String value2) {
            addCriterion("PK_AUDIT between", value1, value2, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotBetween(String value1, String value2) {
            addCriterion("PK_AUDIT not between", value1, value2, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkSignIsNull() {
            addCriterion("PK_SIGN is null");
            return (Criteria) this;
        }

        public Criteria andPkSignIsNotNull() {
            addCriterion("PK_SIGN is not null");
            return (Criteria) this;
        }

        public Criteria andPkSignEqualTo(String value) {
            addCriterion("PK_SIGN =", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotEqualTo(String value) {
            addCriterion("PK_SIGN <>", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignGreaterThan(String value) {
            addCriterion("PK_SIGN >", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SIGN >=", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLessThan(String value) {
            addCriterion("PK_SIGN <", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLessThanOrEqualTo(String value) {
            addCriterion("PK_SIGN <=", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLike(String value) {
            addCriterion("PK_SIGN like", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotLike(String value) {
            addCriterion("PK_SIGN not like", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignIn(List<String> values) {
            addCriterion("PK_SIGN in", values, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotIn(List<String> values) {
            addCriterion("PK_SIGN not in", values, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignBetween(String value1, String value2) {
            addCriterion("PK_SIGN between", value1, value2, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotBetween(String value1, String value2) {
            addCriterion("PK_SIGN not between", value1, value2, "pkSign");
            return (Criteria) this;
        }

        public Criteria andEnablestateIsNull() {
            addCriterion("ENABLESTATE is null");
            return (Criteria) this;
        }

        public Criteria andEnablestateIsNotNull() {
            addCriterion("ENABLESTATE is not null");
            return (Criteria) this;
        }

        public Criteria andEnablestateEqualTo(String value) {
            addCriterion("ENABLESTATE =", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotEqualTo(String value) {
            addCriterion("ENABLESTATE <>", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateGreaterThan(String value) {
            addCriterion("ENABLESTATE >", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateGreaterThanOrEqualTo(String value) {
            addCriterion("ENABLESTATE >=", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLessThan(String value) {
            addCriterion("ENABLESTATE <", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLessThanOrEqualTo(String value) {
            addCriterion("ENABLESTATE <=", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLike(String value) {
            addCriterion("ENABLESTATE like", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotLike(String value) {
            addCriterion("ENABLESTATE not like", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateIn(List<String> values) {
            addCriterion("ENABLESTATE in", values, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotIn(List<String> values) {
            addCriterion("ENABLESTATE not in", values, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateBetween(String value1, String value2) {
            addCriterion("ENABLESTATE between", value1, value2, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotBetween(String value1, String value2) {
            addCriterion("ENABLESTATE not between", value1, value2, "enablestate");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    /**
     *  * cw_bd_accounting
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * cw_bd_accounting 2019-06-13
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}